(: Copyright(c) 2007-2008. Progress Software Corporation. All Rights Reserved. :)
import module namespace common = "http://www.datadirect.com/examples/XQueryWebService" at "common.xquery";

declare variable $xsdImports as element(xs:untyped)* external;
declare variable $allVariablesAsXML as document-node(element(*, xs:untyped))* external;
declare variable $queryFiles as xs:string * external;
declare variable $fileSeparator as xs:string external;

declare variable $XSD := "http://www.w3.org/2001/XMLSchema"; 

declare variable $XMLSCHEMA_TYPES := ( 
"string", "normalizedString", "token", "language", "NMTOKEN", "NMTOKENS",
"Name", "NCNAME", "ID", "IDREF", "IDREFS", "ENTITY", "ENTITIES",
"dateTime", "date", "time", "duration", 
"gYearMonth", "gYear", "gMonthDay", "gDay", "gMonth",  
"float", "double", "decimal", "integer", "nonPositiveInteger", "long", "int", "short", "byte",
"NonNegativeInteger", "unsignedLong", "unsignedInt", "unsignedShort", "unsignedByte", "positiveInteger",
"boolean", "base64Binary", "hexBinary", "anyURI", "QName", "Notation");

declare variable $keys := 
  for $i in $xsdImports 
  return <import key="{concat($i/@prefix, $i/@namespace)}"/>;


declare function local:IsBuiltInXSD($namespace as xs:string, $localName as xs:string) as xs:boolean
{
	$namespace = $XSD and $localName = $XMLSCHEMA_TYPES
};

<queries>
  <imports>{
  	for $k in distinct-values($keys/@key)
 	return
		for $uniqueImport in $xsdImports[concat(@prefix, @namespace) = $k][1]
		return $uniqueImport	
  }
  </imports>,
  {
    for $xq in $queryFiles
    return
	  let $queryName := common:makeName($xq, $fileSeparator) return
      <query name="{$queryName}" fileName="{common:fileName($xq, $fileSeparator)}">
        <input>
          <type>
            <xs:element name="{$queryName}">{
                let $variables := $allVariablesAsXML/Variables[@queryFile = $xq]/varDecl
                return
                  if(count($variables) = 0) then ()
                  else
                    <xs:complexType>
                      <xs:all>{
                        for $var in $variables
                        return
                          let $type := if(local:IsBuiltInXSD($var/@typeNS, $var/@typeLocalName)) then concat("xs:", $var/@typeLocalName)
                                       else "xs:anyType"
                          return <xs:element name="{ $var/@fullNameEscaped }" type="{ $type }"/>
                      }</xs:all>
                    </xs:complexType>
            }
            </xs:element>
          </type>
        </input>
		<output>{
			let $schemaInfo := $xsdImports[string(@queryFile) = $xq] 
			return
			if ($schemaInfo) then
				let $local := if(string-length(string($schemaInfo/@prefix)) > 0 ) then  
							   concat($schemaInfo/@prefix,':',$schemaInfo/@local-name)
							  else $schemaInfo/@local-name
				return
				<element namespace="{$schemaInfo/@namespace}" 
				local-name="{$local}"/>
			else ()
		}
        </output>
     
      </query>
  }
</queries>(: Stylus Studio meta-information - (c) 2004-2007. Progress Software Corporation. All rights reserved.

<metaInformation>
	<scenarios>
		<scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" useresolver="yes" url="" outputurl="" processortype="datadirect" tcpport="-842150451" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline=""
		          additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" host="" port="0" user="" password="" validateoutput="no" validator="internal" customvalidator=""/>
	</scenarios>
	<MapperMetaTag>
		<MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/>
		<MapperBlockPosition></MapperBlockPosition>
		<TemplateContext></TemplateContext>
		<MapperFilter side="source"></MapperFilter>
	</MapperMetaTag>
</metaInformation>
:)